;This file is copyright (c) 1991, 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : procedure 
;Source File     : HELPER.SC
;Author          : David R. Faulkner
;                  Silver Software
;                  (808) 878-2714
;Informant Issue : September 1992
;
;Description     : Adding keyword-sensitive help to the Paradox 4.0 editor
;                  
;
; Paradox Informant
; 10519 E. Stockton Blvd.
; Suite 142
; Elk Grove, CA  95624-9743
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740

proc EditorHelp()
Private EditorArray, ComFile

;Start by making sure we are in the script editor
editor info to EditorArray
if not isassigned(EditorArray["TYPE"]) or
    EditorArray["TYPE"]="MEMO" or
    MenuChoice()<>"Error" then
  beep
  return
endif

ctrlright                         ;goto end of current word
ctrlleft                          ;and right back to the beginning
shiftpress "CtrlRight"            ;'select' current word
editor extract to EditorWord      ;put selected word in variable
right                             ;Unselect current word

;Since the keyboard buffer only takes 15 character, and since 4 are needed
;for control (F1 CtrlZ Enter Enter), only 11 letters can be used for help
;search.
if len(EditorWord)>11 then
  editorword=substr(Editorword,1,9)+".."
endif
ComFile=
        "\180\005"+      ;mov ah 05h
        "\185\000\059"+  ;mov cx 3b00h  ;F1
        "\205\022"+      ;int 22     ;Int 22, Fun 05 is stuff keyboard
                                     ;buffer with the key in cx
        "\180\005"+      ;mov ah 05h
        "\185\026\044"+  ;mov cx 2c1ah  ;CtrlZ
        "\205\022"       ;int 22

for x from 1 to len(EditorWord)
  ComFile=ComFile+
          "\180\005"+                             ;mov ah 05h
          "\185"+substr(EditorWord,x,1)+"\000"+   ;
          "\205\022"                              ;int 22h
endfor

ComFile=ComFile+
        "\180\005"+      ;mov ah 05h
        "\185\013\028"+  ;mov cx 000c  ;enter
        "\205\022"+      ;int 22
        "\180\005"+      ;mov ah 05h
        "\185\013\028"+  ;mov cx 000c  ;enter
        "\205\022"+      ;int 22
        "\180\076"+      ;mov ah 4c
        "\205\033"       ;int 21       ;Int 21, Fun 4c is exit

if isfile("$keystuf.com") then
  run norefresh "del $keystuf.com > nul"
endif
print file "$keystuf.com" ComFile

help
run norefresh noshell "$keystuf.com"
;All PAL control is lost at this point so can't even delete $keystuf.com

endproc
createlib "paradox"
writelib  "paradox" EditorHelp

setkey "F31" EditorHelp()  ;Set Alt F1 to Keyword Sensitive Editor Help